<template>
  <div>
    <heading class="mb-6">User Accounts</heading>
    <custom-select
      :data="filterOptions"
      :title="'Select Status'"
      :searchInput="false"
      :selectedItem="selectedItem"
      :selectItem="selectFilterStatusValue"
      class="select-filter"
    />
    <custom-table
      :columns="tableColumns"
      :data="accounts"
      :toggleBtn="true"
      :toggleBtnClick="changeStatus"
    />
    <pagination-bar
      :previousPage="accountResponse.previousPage"
      :nextPage="accountResponse.nextPage"
      :getTableData="getUserAccounts"
      :pageNumber="pageNumber"
      :getPageNumber="getPageNumber"
    />
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";

export default {
  mounted() {
    this.getUserAccounts(this.allAccountsUrl);
  },
  data() {
    return {
      allAccountsUrl: "/nova-api/accounts",
      tableColumns: [
        { name: "ID", attr: "id" },
        { name: "Account Number", attr: "account_number" },
        { name: "Balance", attr: "balance" },
        { name: "Created At", attr: "created_at" },
        { name: "is Active", attr: "is_active" },
        { name: "Currency", attr: "currency" },
      ],
      filterOptions: [
        { title: "Active", value: 1 },
        { title: "Not Active", value: 0 },
      ],
      selectedItem: [
        { title: "Active", value: 1 },
        { title: "Not Active", value: 0 },
      ],
      pageNumber: 1,
    };
  },
  computed: {
    ...mapGetters("moduleAccount", {
      accounts: "getAccounts",
      accountResponse: "getPagesUrl",
    }),
  },
  methods: {
    ...mapActions("moduleAccount", {
      fetchAccounts: "fetchAccounts",
      changeAccountStatus: "changeAccountStatus",
    }),
    getUserAccounts(url) {
      this.fetchAccounts({
        url: url,
        userID: Nova.config.userId,
        filter: this.selectedItem,
      });
    },
    selectFilterStatusValue(status) {
      var found = false;
      this.selectedItem.forEach((element, index) => {
        if (element.title == status.title) {
          this.selectedItem.splice(index, 1);
          found = true;
        }
      });
      if (!found) {
        this.selectedItem.push(status);
      }
      this.pageNumber = 1;
      this.getUserAccounts(this.allAccountsUrl);
    },
    changeStatus(account) {
      this.changeAccountStatus(account);
      setTimeout(() => {
        this.getUserAccounts(this.allAccountsUrl);
      }, 400);
      this.pageNumber = 1;
    },
    getPageNumber(page) {
      page == "next" ? this.pageNumber++ : this.pageNumber--;
    },
  },
};
</script>
